//=============================================================================
// RPG Maker MV - CT_Bolt's Region Tint
//=============================================================================

/*:
 * @plugindesc [RPG Maker MV] [Tier 1] [Version 1.00] [CT_Bolt - ItemSelectWindowEx]
 * @author CT_Bolt
 *
 * @help
 * Script Calls:
 *   openWeaponSelect(Variable ID)
 *   openArmorSelect(Variable ID)
 *
 * Examples:
 *   openWeaponSelect(1)
 *   openArmorSelect(1)
 * 
 *
 */
//=============================================================================
//=============================================================================

var CTB = CTB || {}; CTB.ItemSelectWindowEx  = CTB.ItemSelectWindowEx || {};
var Imported = Imported || {}; Imported["CT_Bolt ItemSelectWindowEx"] = 1.00;

"use strict";
(function ($_$) {
    function getPluginParameters() {var a = document.currentScript || (function() { var b = document.getElementsByTagName('script'); return b[b.length - 1]; })(); return PluginManager.parameters(a.src.substring((a.src.lastIndexOf('/') + 1), a.src.indexOf('.js')));} $_$.params = getPluginParameters();
	
	$_$['Window_EventItem.prototype.includes'] = Window_EventItem.prototype.includes;
	Window_EventItem.prototype.includes = function(item) {
		let r = $_$['Window_EventItem.prototype.includes'].apply(this, arguments);
		if ($gameMessage.choiceMode === 'weapon'){
			r = DataManager.isWeapon(item);
		}else if ($gameMessage.choiceMode === 'armor'){
			r = DataManager.isArmor(item);
		};
		return r;
	};
	
	$_$['Window_EventItem.prototype.close'] = Window_EventItem.prototype.close;
	Window_EventItem.prototype.close = function() {
		$gameMessage.choiceMode = '';
		$_$['Window_EventItem.prototype.close'].apply(this, arguments);
	};
	
	CTB.ItemSelectWindowEx.choiceWindow = function(varId, data){
		data = data || 'weapon';
		$gameMessage.choiceMode = data;
		
		if (!$gameMessage.isBusy()) {
			$gameMessage.setItemChoice(varId);
			$gameMap._interpreter_index++;
			$gameMap._interpreter.setWaitMode('message');
		};
		return false;
	};
	
})(CTB.ItemSelectWindowEx);

function openWeaponSelect(varId){CTB.ItemSelectWindowEx.choiceWindow(varId, 'weapon');};
function openArmorSelect(varId) {CTB.ItemSelectWindowEx.choiceWindow(varId, 'armor');};