var fun_map_update = Scene_Map.prototype.update;
Scene_Map.prototype.update = function() {
    fun_map_update.call(this);
    if ($gameSwitches.value(57)){
        if (!this.showinfo){
            this.showinfo = new Sprite(new Bitmap(400, 300));
            this.showinfo.x = 30;
            this.showinfo.y = -25;
            this.addChild(this.showinfo);
        } else {
          this.showinfo.bitmap.fontSize = 24;
          this.showinfo.bitmap.clear();
          this.showinfo.bitmap.drawText( '生存天数 : '+ $gameVariables.value(96), 0, 0, 400, 200, 'left' );
          this.showinfo.bitmap.drawText( '天气 : '+ $gameVariables.value(97), 0, 36, 400, 200, 'left' );
          this.showinfo.bitmap.drawText( '时间 : '+ $gameVariables.value(98), 0, 72, 400, 200, 'left' );
          this.showinfo.bitmap.drawText( '声望 : '+ $gameVariables.value(92), 0, 108, 400, 200, 'left' );
          //this.showinfo.bitmap.drawText( '升级经验 : '+ $gameVariables.value(93), 0, 148, 400, 200, 'left' );
    
        }
    } else {
        if (this.showinfo) {
            this.removeChild(this.showinfo); // Remove the window if switch is off
            this.showinfo = null; // Clear the reference to the window
        }
    }
};
//注释掉多余
//-----------------------------------------------------------------------------
// Window_Status
//
// The window for displaying full status on the status screen.

function Window_Status() {
    this.initialize(...arguments);
}

Window_Status.prototype = Object.create(Window_StatusBase.prototype);
Window_Status.prototype.constructor = Window_Status;

Window_Status.prototype.initialize = function(rect) {
    Window_StatusBase.prototype.initialize.call(this, rect);
    this._actor = null;
    this.refresh();
    this.activate();
};

Window_Status.prototype.setActor = function(actor) {
    if (this._actor !== actor) {
        this._actor = actor;
        this.refresh();
    }
};

Window_Status.prototype.refresh = function() {
    Window_StatusBase.prototype.refresh.call(this);
    if (this._actor) {
        this.drawBlock1();
        this.drawBlock2();
    }
};

Window_Status.prototype.drawBlock1 = function() {
    const y = this.block1Y();
    this.drawActorName(this._actor, 6, y, 168);
    //this.drawActorClass(this._actor, 192, y, 168);
    //this.drawActorNickname(this._actor, 432, y, 270);
};

Window_Status.prototype.block1Y = function() {
    return 0;
};

Window_Status.prototype.drawBlock2 = function() {
    const y = this.block2Y();
    this.drawActorFace(this._actor, 12, y);
    this.drawBasicInfo(204, y);
    this.drawExpInfo(456, y);
};

Window_Status.prototype.block2Y = function() {
    const lineHeight = this.lineHeight();
    const min = lineHeight;
    const max = this.innerHeight - lineHeight * 4;
    return Math.floor((lineHeight * 1.4).clamp(min, max));
};

Window_Status.prototype.drawBasicInfo = function(x, y) {
    const lineHeight = this.lineHeight();
    this.drawActorLevel(this._actor, x -0, y + lineHeight * 0 - 92);
    this.drawActorIcons(this._actor, x, y + lineHeight * 1);
    this.placeBasicGauges(this._actor, x - 160, y + lineHeight * 2 + 50);
};

Window_Status.prototype.drawExpInfo = function(x, y) {
    const lineHeight = this.lineHeight();
    const expTotal = TextManager.expTotal.format(TextManager.exp);
    const expNext = TextManager.expNext.format(TextManager.level);
    this.changeTextColor(ColorManager.systemColor());
    //this.drawText(expTotal, x, y + lineHeight * 0, 270);
    this.drawText(expNext, x - 250, y + lineHeight * 2 - 150, 270);
    this.resetTextColor();
    //this.drawText(this.expTotalValue(), x, y + lineHeight * 1, 270, "right");
    this.drawText(this.expNextValue(), x - 270, y + lineHeight * 3 - 215, 270, "right");
};

Window_Status.prototype.expTotalValue = function() {
    if (this._actor.isMaxLevel()) {
        return "-------";
    } else {
        return this._actor.currentExp();
    }
};

Window_Status.prototype.expNextValue = function() {
    if (this._actor.isMaxLevel()) {
        return "-------";
    } else {
        return this._actor.nextRequiredExp();
    }
};


//-----------------------------------------------------------------------------
// Window_StatusParams
//
// The window for displaying parameters on the status screen.

function Window_StatusParams() {
    this.initialize(...arguments);
}

Window_StatusParams.prototype = Object.create(Window_StatusBase.prototype);
Window_StatusParams.prototype.constructor = Window_StatusParams;

Window_StatusParams.prototype.initialize = function(rect) {
    Window_StatusBase.prototype.initialize.call(this, rect);
    this._actor = null;
};

Window_StatusParams.prototype.setActor = function(actor) {
    if (this._actor !== actor) {
        this._actor = actor;
        this.refresh();
    }
};

Window_StatusParams.prototype.maxItems = function() {
    return 2;
};

Window_StatusParams.prototype.itemHeight = function() {
    return this.lineHeight();
};

Window_StatusParams.prototype.drawItem = function(index) {
    const rect = this.itemLineRect(index);
    const paramId = index + 2;
    const name = TextManager.param(paramId);
    const value = this._actor.param(paramId);
    this.changeTextColor(ColorManager.systemColor());
    this.drawText(name, rect.x, rect.y, 160);
    this.resetTextColor();
    this.drawText(value, rect.x + 160, rect.y, 60, "right");
};

Window_StatusParams.prototype.drawItemBackground = function(/*index*/) {
    //
};